Index: src/main/webapp/domainsrepo/7issues/7issues.json
===================================================================
--- src/main/webapp/domainsrepo/7issues/7issues.json	(revision 1)
+++ src/main/webapp/domainsrepo/7issues/7issues.json	(revision 2)
@@ -3,23 +3,23 @@
 	"issuesValues": {
 		"i1": {
-			"range": ["0", "9", "1"]
+			"range": [0, 9, 1]
 		},
 		"i2": {
-			"range": ["0", "9", "1"]
+			"range": [0, 9, 1]
 		},
 		"i3": {
-			"range": ["0", "9", "1"]
+			"range": [0, 9, 1]
 		},
 		"i4": {
-			"range": ["0", "9", "1"]
+			"range": [0, 9, 1]
 		},
 		"i5": {
-			"range": ["0", "9", "1"]
+			"range": [0, 9, 1]
 		},
 		"i6": {
-			"range": ["0", "9", "1"]
+			"range": [0, 9, 1]
 		},
 		"i7": {
-			"range": ["0", "9", "1"]
+			"range": [0, 9, 1]
 		}
 	}
Index: src/main/webapp/domainsrepo/7issues/7issues1.json
===================================================================
--- src/main/webapp/domainsrepo/7issues/7issues1.json	(revision 1)
+++ src/main/webapp/domainsrepo/7issues/7issues1.json	(revision 2)
@@ -9,5 +9,4 @@
 					"highValue": 9,
 					"highUtility": 0.99
-
 				}
 			},
@@ -18,5 +17,4 @@
 					"highValue": 9,
 					"highUtility": 0.97
-
 				}
 			},
@@ -27,5 +25,4 @@
 					"highValue": 9,
 					"highUtility": 0.96
-
 				}
 			},
@@ -36,5 +33,4 @@
 					"highValue": 9,
 					"highUtility": 0.94
-
 				}
 			},
@@ -45,5 +41,4 @@
 					"highValue": 9,
 					"highUtility": 0.93
-
 				}
 			},
@@ -54,5 +49,4 @@
 					"highValue": 9,
 					"highUtility": 0.92
-
 				}
 			},
@@ -63,5 +57,4 @@
 					"highValue": 9,
 					"highUtility": 0.91
-
 				}
 			}
@@ -80,23 +73,51 @@
 			"issuesValues": {
 				"i1": {
-					"range": ["0", "9", "1"]
+					"range": [
+						0,
+						9,
+						1
+					]
 				},
 				"i2": {
-					"range": ["0", "9", "1"]
+					"range": [
+						0,
+						9,
+						1
+					]
 				},
 				"i3": {
-					"range": ["0", "9", "1"]
+					"range": [
+						0,
+						9,
+						1
+					]
 				},
 				"i4": {
-					"range": ["0", "9", "1"]
+					"range": [
+						0,
+						9,
+						1
+					]
 				},
 				"i5": {
-					"range": ["0", "9", "1"]
+					"range": [
+						0,
+						9,
+						1
+					]
 				},
 				"i6": {
-					"range": ["0", "9", "1"]
+					"range": [
+						0,
+						9,
+						1
+					]
 				},
 				"i7": {
-					"range": ["0", "9", "1"]
+					"range": [
+						0,
+						9,
+						1
+					]
 				}
 			}
Index: src/main/webapp/domainsrepo/7issues/7issues2.json
===================================================================
--- src/main/webapp/domainsrepo/7issues/7issues2.json	(revision 1)
+++ src/main/webapp/domainsrepo/7issues/7issues2.json	(revision 2)
@@ -9,5 +9,4 @@
 					"highValue": 9,
 					"highUtility": 0.11
-
 				}
 			},
@@ -18,5 +17,4 @@
 					"highValue": 9,
 					"highUtility": 0.21
-
 				}
 			},
@@ -27,5 +25,4 @@
 					"highValue": 9,
 					"highUtility": 0.13
-
 				}
 			},
@@ -36,5 +33,4 @@
 					"highValue": 9,
 					"highUtility": 0.14
-
 				}
 			},
@@ -45,5 +41,4 @@
 					"highValue": 9,
 					"highUtility": 0.15
-
 				}
 			},
@@ -54,5 +49,4 @@
 					"highValue": 9,
 					"highUtility": 0.16
-
 				}
 			},
@@ -63,5 +57,4 @@
 					"highValue": 9,
 					"highUtility": 0.17
-
 				}
 			}
@@ -80,23 +73,51 @@
 			"issuesValues": {
 				"i1": {
-					"range": ["0", "9", "1"]
+					"range": [
+						0,
+						9,
+						1
+					]
 				},
 				"i2": {
-					"range": ["0", "9", "1"]
+					"range": [
+						0,
+						9,
+						1
+					]
 				},
 				"i3": {
-					"range": ["0", "9", "1"]
+					"range": [
+						0,
+						9,
+						1
+					]
 				},
 				"i4": {
-					"range": ["0", "9", "1"]
+					"range": [
+						0,
+						9,
+						1
+					]
 				},
 				"i5": {
-					"range": ["0", "9", "1"]
+					"range": [
+						0,
+						9,
+						1
+					]
 				},
 				"i6": {
-					"range": ["0", "9", "1"]
+					"range": [
+						0,
+						9,
+						1
+					]
 				},
 				"i7": {
-					"range": ["0", "9", "1"]
+					"range": [
+						0,
+						9,
+						1
+					]
 				}
 			}
Index: src/main/webapp/domainsrepo/jobs/jobs1_20.json
===================================================================
--- src/main/webapp/domainsrepo/jobs/jobs1_20.json	(revision 2)
+++ src/main/webapp/domainsrepo/jobs/jobs1_20.json	(revision 2)
@@ -0,0 +1,403 @@
+{
+	"DefaultPartialOrdering": {
+		"name": "jobs1_20",
+		"domain": {
+			"name": "jobs",
+			"issuesValues": {
+				"lease car": {
+					"values": ["yes", "no"]
+				},
+				"permanent contract": {
+					"values": ["yes", "no"]
+				},
+				"career development opportunities": {
+					"values": ["low", "medium", "high"]
+				},
+				"fte": {
+					"values": ["0.6", "0.8", "1.0"]
+				},
+				"salary": {
+					"values": ["2000", "2500", "3000", "3500", "4000"]
+				},
+				"work from home": {
+					"values": ["0", "1", "2"]
+				}
+			}
+		},
+		"better": [
+			[0, 34],
+			[2, 9],
+			[3, 5],
+			[6, 23],
+			[12, 18],
+			[13, 27],
+			[14, 28],
+			[15, 37],
+			[17, 28],
+			[19, 1],
+			[20, 29],
+			[21, 24],
+			[22, 8],
+			[25, 10],
+			[26, 16],
+			[30, 24],
+			[31, 32],
+			[33, 7],
+			[35, 4],
+			[36, 11]
+		],
+		"bids": [{
+			"issuevalues": {
+				"lease car": "yes",
+				"permanent contract": "yes",
+				"career development opportunities": "low",
+				"fte": "0.8",
+				"salary": "4000",
+				"work from home": "0"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "no",
+				"permanent contract": "no",
+				"career development opportunities": "high",
+				"fte": "0.6",
+				"salary": "2000",
+				"work from home": "1"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "yes",
+				"permanent contract": "no",
+				"career development opportunities": "low",
+				"fte": "0.8",
+				"salary": "2000",
+				"work from home": "0"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "no",
+				"permanent contract": "yes",
+				"career development opportunities": "high",
+				"fte": "0.8",
+				"salary": "2500",
+				"work from home": "2"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "no",
+				"permanent contract": "yes",
+				"career development opportunities": "low",
+				"fte": "0.6",
+				"salary": "2000",
+				"work from home": "2"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "no",
+				"permanent contract": "no",
+				"career development opportunities": "high",
+				"fte": "0.6",
+				"salary": "2500",
+				"work from home": "2"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "no",
+				"permanent contract": "yes",
+				"career development opportunities": "low",
+				"fte": "1.0",
+				"salary": "3500",
+				"work from home": "2"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "no",
+				"permanent contract": "yes",
+				"career development opportunities": "medium",
+				"fte": "1.0",
+				"salary": "3000",
+				"work from home": "0"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "no",
+				"permanent contract": "yes",
+				"career development opportunities": "high",
+				"fte": "0.6",
+				"salary": "3500",
+				"work from home": "1"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "no",
+				"permanent contract": "no",
+				"career development opportunities": "medium",
+				"fte": "0.6",
+				"salary": "2000",
+				"work from home": "1"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "yes",
+				"permanent contract": "no",
+				"career development opportunities": "high",
+				"fte": "0.6",
+				"salary": "2000",
+				"work from home": "0"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "no",
+				"permanent contract": "no",
+				"career development opportunities": "medium",
+				"fte": "0.8",
+				"salary": "3500",
+				"work from home": "2"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "yes",
+				"permanent contract": "yes",
+				"career development opportunities": "high",
+				"fte": "0.6",
+				"salary": "2500",
+				"work from home": "2"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "no",
+				"permanent contract": "yes",
+				"career development opportunities": "low",
+				"fte": "0.8",
+				"salary": "3000",
+				"work from home": "1"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "yes",
+				"permanent contract": "yes",
+				"career development opportunities": "high",
+				"fte": "0.8",
+				"salary": "2000",
+				"work from home": "2"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "no",
+				"permanent contract": "yes",
+				"career development opportunities": "high",
+				"fte": "1.0",
+				"salary": "3500",
+				"work from home": "0"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "no",
+				"permanent contract": "yes",
+				"career development opportunities": "medium",
+				"fte": "0.8",
+				"salary": "4000",
+				"work from home": "0"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "yes",
+				"permanent contract": "no",
+				"career development opportunities": "medium",
+				"fte": "0.8",
+				"salary": "3000",
+				"work from home": "1"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "no",
+				"permanent contract": "yes",
+				"career development opportunities": "high",
+				"fte": "0.8",
+				"salary": "2000",
+				"work from home": "0"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "no",
+				"permanent contract": "yes",
+				"career development opportunities": "low",
+				"fte": "1.0",
+				"salary": "3000",
+				"work from home": "2"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "yes",
+				"permanent contract": "no",
+				"career development opportunities": "medium",
+				"fte": "1.0",
+				"salary": "4000",
+				"work from home": "1"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "no",
+				"permanent contract": "no",
+				"career development opportunities": "low",
+				"fte": "1.0",
+				"salary": "3500",
+				"work from home": "2"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "yes",
+				"permanent contract": "yes",
+				"career development opportunities": "medium",
+				"fte": "1.0",
+				"salary": "2500",
+				"work from home": "2"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "yes",
+				"permanent contract": "no",
+				"career development opportunities": "low",
+				"fte": "1.0",
+				"salary": "3000",
+				"work from home": "2"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "no",
+				"permanent contract": "yes",
+				"career development opportunities": "medium",
+				"fte": "0.8",
+				"salary": "3000",
+				"work from home": "2"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "no",
+				"permanent contract": "no",
+				"career development opportunities": "medium",
+				"fte": "0.8",
+				"salary": "2000",
+				"work from home": "1"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "yes",
+				"permanent contract": "yes",
+				"career development opportunities": "low",
+				"fte": "0.8",
+				"salary": "3500",
+				"work from home": "2"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "yes",
+				"permanent contract": "no",
+				"career development opportunities": "medium",
+				"fte": "0.6",
+				"salary": "4000",
+				"work from home": "0"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "no",
+				"permanent contract": "no",
+				"career development opportunities": "low",
+				"fte": "0.6",
+				"salary": "2000",
+				"work from home": "0"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "no",
+				"permanent contract": "no",
+				"career development opportunities": "low",
+				"fte": "0.6",
+				"salary": "3500",
+				"work from home": "1"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "yes",
+				"permanent contract": "no",
+				"career development opportunities": "high",
+				"fte": "0.8",
+				"salary": "4000",
+				"work from home": "1"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "no",
+				"permanent contract": "yes",
+				"career development opportunities": "low",
+				"fte": "0.8",
+				"salary": "4000",
+				"work from home": "1"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "no",
+				"permanent contract": "yes",
+				"career development opportunities": "high",
+				"fte": "0.8",
+				"salary": "2500",
+				"work from home": "0"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "no",
+				"permanent contract": "yes",
+				"career development opportunities": "medium",
+				"fte": "1.0",
+				"salary": "4000",
+				"work from home": "0"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "yes",
+				"permanent contract": "no",
+				"career development opportunities": "high",
+				"fte": "0.6",
+				"salary": "2500",
+				"work from home": "2"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "yes",
+				"permanent contract": "yes",
+				"career development opportunities": "low",
+				"fte": "0.8",
+				"salary": "3500",
+				"work from home": "0"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "yes",
+				"permanent contract": "no",
+				"career development opportunities": "high",
+				"fte": "1.0",
+				"salary": "4000",
+				"work from home": "1"
+			}
+		}, {
+			"issuevalues": {
+				"lease car": "yes",
+				"permanent contract": "no",
+				"career development opportunities": "medium",
+				"fte": "0.8",
+				"salary": "3500",
+				"work from home": "2"
+			}
+		}],
+		"reservationBid": {
+			"issuevalues": {
+				"lease car": "no",
+				"permanent contract": "no",
+				"career development opportunities": "low",
+				"fte": "0.6",
+				"salary": "3500",
+				"work from home": "1"
+			}
+		}
+	}
+}