Index: /javavenv/pom.xml
===================================================================
--- /javavenv/pom.xml	(revision 5)
+++ /javavenv/pom.xml	(revision 6)
@@ -5,5 +5,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>javavenv</artifactId>
-	<version>2.0.4</version>
+	<version>2.0.5</version>
 
 
@@ -17,5 +17,5 @@
 		<!-- <tomcat.version>8.0.53</tomcat.version> -->
 		<tomcat.version>8.5.20</tomcat.version>
-		<geniusweb.version>2.0.4</geniusweb.version>
+		<geniusweb.version>${project.version}</geniusweb.version>
 	</properties>
 
@@ -54,5 +54,5 @@
 			<groupId>commons-io</groupId>
 			<artifactId>commons-io</artifactId>
-			<version>2.8.0</version>
+			<version>2.11.0</version>
 		</dependency>
 		<dependency>
Index: /javavenv/src/main/java/geniusweb/javavenv/PythonVenv.java
===================================================================
--- /javavenv/src/main/java/geniusweb/javavenv/PythonVenv.java	(revision 5)
+++ /javavenv/src/main/java/geniusweb/javavenv/PythonVenv.java	(revision 6)
@@ -24,5 +24,5 @@
 	private final static String GENIUSWEBVENV = "GeniusWebPythonVenvs";
 	private final static String PYTHON3EXE = "PYTHON3EXE";
-	private final static String PYTHON3 = System.getenv(PYTHON3EXE);
+	public final static String PYTHON3 = System.getenv(PYTHON3EXE);
 	private final Path venvpath;
 	private final Reporter logger;
Index: /javavenv/src/test/java/geniusweb/javavenv/PythonCallTest.java
===================================================================
--- /javavenv/src/test/java/geniusweb/javavenv/PythonCallTest.java	(revision 5)
+++ /javavenv/src/test/java/geniusweb/javavenv/PythonCallTest.java	(revision 6)
@@ -9,4 +9,5 @@
 
 public class PythonCallTest {
+
 	@Test(expected = IllegalArgumentException.class)
 	public void testSmokeNullPython() {
@@ -21,10 +22,10 @@
 	@Test(expected = IllegalArgumentException.class)
 	public void testSmokeEmptyArg() {
-		new Call("/usr/local/bin/python3", null, 1000);
+		new Call(PythonVenv.PYTHON3, null, 1000);
 	}
 
 	@Test
 	public void testSmoke() {
-		new Call("/usr/local/bin/python3", Arrays.asList("troep"), 1000);
+		new Call(PythonVenv.PYTHON3, Arrays.asList("troep"), 1000);
 	}
 
@@ -33,5 +34,5 @@
 			throws InterruptedException, IOException, PythonError {
 		try {
-			Call c = new Call("/usr/local/bin/python3",
+			Call c = new Call(PythonVenv.PYTHON3,
 					Arrays.asList("troep"), 1000);
 			c.run();
@@ -46,5 +47,5 @@
 	public void testPrint()
 			throws InterruptedException, IOException, PythonError {
-		Call c = new Call("/usr/local/bin/python3",
+		Call c = new Call(PythonVenv.PYTHON3,
 				Arrays.asList("src/test/resources/print.py"), 1000);
 		assertEquals("hello\n", c.run());
@@ -54,5 +55,5 @@
 	public void testPrintNoNewline()
 			throws InterruptedException, IOException, PythonError {
-		Call c = new Call("/usr/local/bin/python3",
+		Call c = new Call(PythonVenv.PYTHON3,
 				Arrays.asList("src/test/resources/printnonewline.py"), 1000);
 		assertEquals("hello", c.run());
@@ -62,5 +63,5 @@
 	public void testPrint3xNoNewline()
 			throws InterruptedException, IOException, PythonError {
-		Call c = new Call("/usr/local/bin/python3",
+		Call c = new Call(PythonVenv.PYTHON3,
 				Arrays.asList("src/test/resources/print3xnonewline.py"), 1000);
 		// the call collects till the connection closes, also if it's multi
@@ -72,5 +73,5 @@
 	public void testWait5Sec()
 			throws InterruptedException, IOException, PythonError {
-		Call c = new Call("/usr/local/bin/python3",
+		Call c = new Call(PythonVenv.PYTHON3,
 				Arrays.asList("src/test/resources/wait5sec.py"), 10000);
 		assertEquals("hello world\n", c.run());
@@ -81,5 +82,5 @@
 			throws InterruptedException, IOException, PythonError {
 		try {
-			Call c = new Call("/usr/local/bin/python3",
+			Call c = new Call(PythonVenv.PYTHON3,
 					Arrays.asList("src/test/resources/wait5sec.py"), 1000);
 			c.run();
@@ -95,5 +96,5 @@
 			throws InterruptedException, IOException, PythonError {
 		try {
-			Call c = new Call("/usr/local/bin/python3",
+			Call c = new Call(PythonVenv.PYTHON3,
 					Arrays.asList("src/test/resources/printerr.py"), 1000);
 			c.run();
@@ -109,5 +110,5 @@
 			throws InterruptedException, IOException, PythonError {
 		try {
-			Call c = new Call("/usr/local/bin/python3",
+			Call c = new Call(PythonVenv.PYTHON3,
 					Arrays.asList("src/test/resources/throw.py"), 1000);
 			c.run();
Index: /pypartiesserver/pom.xml
===================================================================
--- /pypartiesserver/pom.xml	(revision 5)
+++ /pypartiesserver/pom.xml	(revision 6)
@@ -6,5 +6,5 @@
 	<artifactId>pypartiesserver</artifactId>
 	<packaging>war</packaging>
-	<version>2.0.4</version> <!-- must equal ${geniusweb.version} -->
+	<version>2.0.5</version> <!-- must equal ${geniusweb.version} -->
 	<name>partiesserver Maven Webapp</name>
 	<url>http://maven.apache.org</url>
@@ -19,5 +19,5 @@
 		<!-- <tomcat.version>8.0.53</tomcat.version> -->
 		<tomcat.version>8.5.20</tomcat.version>
-		<geniusweb.version>2.0.4</geniusweb.version>
+		<geniusweb.version>${project.version}</geniusweb.version>
 	</properties>
 